LOWER_LEVEL:		equ	0
UPPER_LEVEL:		equ	1

CarColourBlue:	equ	0
CarColourRed:	equ	1
CarColourYellow	equ	2
CarColourGreen:	equ	3
DroneColourBlue:	equ	4
DroneColourRed:	equ	5
DroneColourYellow equ	6
DroneColourGreen:	equ	7

NUM_CAR_FRAMES:		equ	30

CAR_ANGLE_NORTH:	equ	$80
CAR_ANGLE_SOUTH:	equ	$0
CAR_ANGLE_WEST:		equ	$c0
CAR_ANGLE_EAST:		equ	$40

CAR_PLAYER_BLUE:	equ	0*NUM_CAR_FRAMES	;0
CAR_PLAYER_RED:		equ	1*NUM_CAR_FRAMES	;30
CAR_PLAYER_YELLOW:	equ	2*NUM_CAR_FRAMES	;60
CAR_PLAYER_GREEN:	equ	3*NUM_CAR_FRAMES
CAR_DRONE:		equ	4*NUM_CAR_FRAMES
CAR_DRONE_BLUE:		equ	4*NUM_CAR_FRAMES	;90
CAR_DRONE_RED:		equ	5*NUM_CAR_FRAMES	
CAR_DRONE_YELLOW:	equ	6*NUM_CAR_FRAMES
CAR_DRONE_GREEN:	equ	7*NUM_CAR_FRAMES

CAR_1:		equ	0
CAR_2:		equ	1
CAR_3:		equ	2
CAR_4:		equ	3

CAR_SPEED_1:	equ	1
CAR_SPEED_2:	equ	2
CAR_SPEED_3:	equ	3
CAR_SPEED_4:	equ	4
CAR_SPEED_5:	equ	5
CAR_SPEED_6:	equ	6
CAR_SPEED_7:	equ	7
CAR_SPEED_8:	equ	8

; Top speed
; Turbo Accelleration
; Increase Traction


CAR_MINIMUM_TRACTION:	equ	$400		; Increase this for much better traction. (280-400)	
CAR_PLAYER_TRACTION:	equ	$280		; between 280-400, 280 car is very sluggish

CAR_DRONE_TRACTION:	equ	$300

CAR_DEFAULT_STEER:	equ	$400		; If this is lower then the drag/understeer is less, make it greater and over steer is more

CAR_DELAY_OUTSKID:	equ	$40
CAR_DEFAULT_STEER_MOD:	equ	$20		; This needs to be linked to the throttle/speed (control skid)

CAR_TRACTION_MOD:	equ	$1		; $1= Lowest $10=Highest Traction


CAR_DEFAULT_DRAG:	equ	$500
CAR_DRAG_MOD:		equ	$280

DRONE_MAX_THROTTLE:	equ	$420

maxCars:		equ 	4

carStructShiftSize:	equ	8
carStructSize:		equ	1<<carStructShiftSize	; 256

carExplodeThreshold:	equ	$3e0		; Cars will explode if they hit a barrier above this velocity
carInitMaxThrottle:	equ	$300		; Controls nothing...???
carInitMaxHorsePower:	equ	$06		; Controls accelleration
carInitMaxBraking:	equ	$08		; Controls faster braking

carMaxThrottle:		equ	0		; .long
carMaxHorsePower:	equ	4		; .long
carMaxBraking:		equ	8		; .long
carStateDirection:	equ	12		; .word
carFrameDirection:	equ	14		; .word	
carCurrentThrottle:	equ	16		; .long
carHiscoreInitials:	equ	20		; .long
carThisSampleThrottle:	equ	24		; .word
carLastSampleThrottle:	equ	26		; .word
carXpos:		equ	32		; .long
carYpos:		equ	36		; .long
carStateButton:		equ	40		; .word
carFrameButton:		equ	42		; .word
carColour:		equ	44		; .long
carLevel:		equ	48		; .long
carIsDrone:		equ	52		; .word
carTrackPointer:	equ	56		; .long	 
;carTrackOffset 		equ	60		; .long
carOldLevel:		equ	64		; .long
carLastYpos:		equ	68		; .long
carAttrTraction:	equ	72		; .byte
carAttrTurbo:		equ	73		; .byte
carAttrSpeed:		equ	74		; .byte
carOutOfRace:		equ	75		; .byte
carCurrentFrame:	equ	76		; .word
carTimeInPlay:		equ	78		; .long
carCurrentTraction:	equ	86		; .word
carControlDisable:	equ	88		; .word
carLastCollisionAngle:	equ	90		; .byte
carShortTimer:		equ	91		; .byte
carCollisionDiff:	equ	94		; .word
carLastCheckPoint:	equ	96		; .byte
carCheckPoints:		equ	97		; .byte
carOnLap:		equ	98		; .word
carHasNitro:		equ	100		; .word
carSpanners:		equ	102		; .word
carTouchingCars:	equ	104		; .byte
carLastTouchingCars:	equ	105		; .byte
carDroneCornerSpeed:	equ	106		; .word
carScore:		equ	108		; .long
carUpdateLap:		equ	112		; .word
carUpdateSpanners:	equ	114		; .word
carScoreMultiplier:	equ	116		; .long
carUpdateScore:		equ	120		; .word
;carUpdatePushButton:	equ	122		; .word
carUpdateOSD:		equ	124		; .word
carWheelAngle:		equ	126		; .bword (byte read, word update)
carLastWheelAngle:	equ	128		; .bword (byte read, word update)
carDragAngle:		equ	130		; .bword (byte read, word update)
carDragMod:		equ	132		; .word
carSteerMod:		equ	136		; .word
carTractionMod:		equ	138		; .word
carWheelDirection:	equ	140		; .byte
carLastWheelDirection:	equ	141		; .byte
carHiScoreAlphaPos:	equ	142		; .byte
carNumber:		equ	144		; .long
carRebounding:		equ	148		; .word
;carLastState:		equ	152		; .word
carTimer:		equ	156		; .long
carCrashXpos:		equ	160		; .long
carCrashYpos:		equ	164		; .long
carSteerTime:		equ	168		; .word
carFrontCollisionOffset:	equ	170		; .word .... 
carApplyThrottle:	equ	172		; .word
carSteerTimeOld:	equ	174		; .word
carElevation:		equ	176		; .word
carIsFalling:		equ	178		; .word
carIsFallingIndex:	equ	180		; .word
carControlEnabled:	equ	182		; .word
carCheckPointXpos:	equ	184		; .long
carCheckPointYpos:	equ	188		; .long
carCheckPointWheelAngle	equ	192		; .byte
carCheckPointElevation:	equ	194		; .word
carCheckPointLevel:	equ	196		; .long
carDroneGuideAngle:	equ	200		; .byte 
carDroneLastGuideAngle:	equ	201		; .byte 
carCommandBlock:	equ	202		; .byte
carLastCommandBlock:	equ	203		; .byte
carCommandDiff:		equ	204		; .word
carDroneStartDelay:	equ	206		; .word
carTimeLap1:		equ	208		; .long
carTimeLap2:		equ	212		; .long
carTimeLap3:		equ	216		; .long
carTimeLap4:		equ	220		; .long
carTimeSinceLastCheckPoint:	equ	224	; .word
carOnTrack:		equ	228		; .word
carIsDroneLast:		equ	230		; .word
carFrontTerrainBlock:	equ	232		; .byte
carRearTerrainBlock:	equ	233		; .byte
carRearCollisionOffset:	equ	234		; .word
carUnused1:		equ	236		; .word
carSpinTimer:		equ	238		; .word
carPriOveride:		equ	240		; .word
carExploding:		equ	242		; .word
carRampAngleAdjust:	equ	246		; .word
carLastElevation:	equ	248		; .word
carSoundScreetch:	equ	250		; .byte
carProtectionByte:	equ	251		; .byte
carLandFlag:		equ	252		; .word


